<script lang="ts">
import { defineComponent } from 'vue';

export const textTypes = ['title-1', 'title-3', 'title-4', 'text-1', 'text-2', 'text-3', 'text-4', 'text-5'];
export const textColors = [
  'primary',
  'primary-text',
  // 'secondary',
  'title', // #000
  'secondary-title', // #242424
  'subtitle', // #fff
  // 'secondary-subtitle',
  'text', // #000
  'secondary-text', // #424242
  'third-text', // #6B778C
  'error',
];
export const textWeight = ['bold', 'normal'];

export default defineComponent({
  name: 'JText',
  props: {
    type: {
      type: String,
      default: 'text-1',
      validator: (value: string): boolean => textTypes.includes(value),
    },
    color: {
      type: String,
      default: '',
      validator: (value: string): boolean => textColors.includes(value),
    },
    weight: {
      type: String,
      default: '',
      validator: (value: string): boolean => textWeight.includes(value),
    },
    tag: {
      type: [String, Object],
      default: 'span',
    },
  },
});
</script>

<template>
  <component
    :is="tag"
    class="j-text"
    :class="[type, `${color}-color`, weight]"
  >
    <slot />
  </component>
</template>

<style lang="scss" scoped>
@use './variables.scss';

.j-text {
  &.primary-color {
    color: rgb(var(--j-primary-color));
  }

  &.primary-text-color {
    color: rgb(var(--j-primary-text-color));
  }

  &.title-color {
    color: rgb(var(--j-title-color));
  }

  &.subtitle-color {
    color: rgb(var(--j-subtitle-color));
  }

  &.secondary-title-color {
    color: rgb(var(--j-secondary-title-color));
  }

  &.secondary-text-color {
    color: rgb(var(--j-secondary-text-color));
  }

  &.third-text-color {
    color: rgb(var(--j-third-text-color));
  }

  &.error-color {
    color: rgb(var(--j-error-color));
  }

  &.title {
    &-1 {
      font-size: map-get(variables.$j-text, title, 1, font-size);
      font-weight: map-get(variables.$j-text, title, 1, font-weight);
    }

    &-3 {
      font-size: map-get(variables.$j-text, title, 3, font-size);
      font-weight: map-get(variables.$j-text, title, 3, font-weight);
    }

    &-4 {
      font-size: map-get(variables.$j-text, title, 4, font-size);
      font-weight: map-get(variables.$j-text, title, 4, font-weight);
    }
  }

  &.text {
    &-1 {
      font-size: map-get(variables.$j-text, text, 1, font-size);
      font-weight: map-get(variables.$j-text, text, 1, font-weight);
    }

    &-2 {
      font-size: map-get(variables.$j-text, text, 2, font-size);
      font-weight: map-get(variables.$j-text, text, 2, font-weight);
    }

    &-3 {
      font-size: map-get(variables.$j-text, text, 3, font-size);
      font-weight: map-get(variables.$j-text, text, 3, font-weight);
    }

    &-4 {
      font-size: map-get(variables.$j-text, text, 4, font-size);
      font-weight: map-get(variables.$j-text, text, 4, font-weight);
    }

    &-5 {
      font-size: map-get(variables.$j-text, text, 5, font-size);
      font-weight: map-get(variables.$j-text, text, 5, font-weight);
    }

    &-6 {
      font-size: map-get(variables.$j-text, text, 6, font-size);
      font-weight: map-get(variables.$j-text, text, 6, font-weight);
    }
  }

  &.bold {
    font-weight: 600;
  }

  &.normal {
    font-weight: 400;
  }
}
</style>
